/*
Copyright (c) 2005 bayside

Permission is hereby granted, free of charge, to any person 
obtaining a copy of this software and associated documentation files 
(the "Software"), to deal in the Software without restriction, 
including without limitation the rights to use, copy, modify, merge, 
publish, distribute, sublicense, and/or sell copies of the Software, 
and to permit persons to whom the Software is furnished to do so, 
subject to the following conditions:

The above copyright notice and this permission notice shall be 
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#if !defined(_TEXTFIELD_H_INCLUDED_)
#define _TEXTFIELD_H_INCLUDED_

/** eLXgtB[hő咷 */
#define MAX_TEXT_LEN 128

namespace baygui {
	/**
	 eLXg{bNXNX
	*/
	class TextField : public Component {
	private:
		/** J[\̈ʒu */
		int textPtr;
		/** ̒ */
		int textLen;
		/** ItZbgX */
		int offx;
		/** ItZbgY */
		int offy;
		/**  */
		char text[MAX_TEXT_LEN];
		
	protected:
		/** eLXgCxg */
		Event textEvent;
		/** TextListenerꗗ */
		Vector textListenerList;
		
	private:
		/** 1} */
		virtual void insertCharacter(char c);
		
		/** ꕶ폜 */
		virtual void deleteCharacter();

	public:
		/** RXgN^ */
		TextField();
		
		/** fXgN^ */
		virtual ~TextField();
		
		/**
		 eLXgݒ肷
		 @param text
		 */
		virtual void setText(const String& text);
		
		/** eLXg𓾂 */
		inline char* getText() { return this->text; }
		
		/** `nh */
		virtual void paint(Graphics* g);
		
		/** Cxgnh */
		virtual void processEvent(Event* event);
		
		/** TextListenerǉ */
		virtual void addTextListener(TextListener* l);
		
		/** TextListener폜 */
		virtual void removeTextListener(TextListener* l);
		
		/** TextEvent */
		virtual void processTextEvent(TextEvent* e);
	};
}

#endif // _TEXTFIELD_H_INCLUDED_
