/*
Copyright (c) 2005 bayside

Permission is hereby granted, free of charge, to any person 
obtaining a copy of this software and associated documentation files 
(the "Software"), to deal in the Software without restriction, 
including without limitation the rights to use, copy, modify, merge, 
publish, distribute, sublicense, and/or sell copies of the Software, 
and to permit persons to whom the Software is furnished to do so, 
subject to the following conditions:

The above copyright notice and this permission notice shall be 
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#if !defined(_MOUSEEVENT_H_INCLUDED_)
#define _MOUSEEVENT_H_INCLUDED_

namespace baygui {
	/**
	 }EXCxgNX
	*/
	class MouseEvent : public Event {
	public:
		static const int BUTTON_LEFT = 1;
		static const int BUTTON_RIGHT = 2;
		static const int BUTTON_MIDDLE = 3;
		
	private:
		/** XW */
		int x;
		/** YW */
		int y;
		/** {^ */
		dword button;
		
	public:
		/** ftHgRXgN^ */
		MouseEvent() {
			setType(MOUSE_PRESSED);
			setSource(NULL);
			this->x = this->y = 0;
			this->button = 0;
		}
		
		/**
		 RXgN^.
		 x, y ̓CEBhE̓̈̍ɑ΂鑊΍WłB
		 ΍W(ax,ay)͈ȉ̂悤Ɏ擾B
		 <ul>
		 <li> ax = x + getMainWindow()->getRect()->getX() + Frame::getInsets()->left;
		 <li> ay = y + getMainWindow()->getRect()->getY() + Frame::getInsets()->top;
		 </ul>
		 @param type type Cxg^Cv
		 @param source Cxg
		 @param x XWi΍Wj
		 @param y YWi΍Wj
		*/
		MouseEvent(int type, Component* source, int x, int y)
		{
			setType(type);
			setSource(source);
			this->x = x;
			this->y = y;
		}
		
		/** fXgN^ */
		virtual ~MouseEvent() {}
		
		/** XW𓾂 */
		inline int getX() { return this->x; }
		
		/** XWݒ肷 */
		inline void setX(int x) { this->x = x; }
		
		/** YW𓾂 */
		inline int getY() { return this->y; }
		
		/** YWݒ肷 */
		inline void setY(int y) { this->y = y; }
		
		/** {^ʂ𓾂 */
		inline dword getButton() { return this->button; }
		
		/** {^ʂݒ肷 */
		inline void setButton(dword button) { this->button = button; }
	};
}

#endif // _MOUSEEVENT_H_INCLUDED_
