/*!
	\file  main.cpp
	\brief  MonaForms GUIT[o C

	This software is in the public domain.
	There are no restrictions on any sort of usage of this software.

	\author   
	\version $Revision: 1.4 $
	\date   create: update:$Date: 2005/08/15 05:23:13 $
*/

#include "Rectangle.h"
#define _R ::System::Drawing::Rectangle

#include <servers/gui.h>
#include <monapi/messages.h>
#include <monapi/CString.h>
#include <monalibc.h>

#include "image.h"
#include "screen.h"
#include "utils.h"
#include "window.h"

using namespace MonAPI;

// ʃobt@
extern guiserver_bitmap* screen_buffer;

// vZXԋʃp[^
CommonParameters* commonParams;
// ǎ
guiserver_bitmap* wallpaper = NULL;
// ʁA폜ʁAʂ̃XebvAʂ̍ݎ(ms)
int we_creation = 0, we_destruction = 0, we_step = 6, we_wait = 30;

// NCAg̃Xg
static HList<dword> clients;
// LɊmۂtHg
static monapi_cmemoryinfo* default_font = NULL;
// ǎJƂɃvvgɏ\邩ǂ
static bool wallpaper_prompt = false;
// X^[gAbvAvP[V
static HList<CString>* startup = NULL;

/*!
\brief ReadFont
	 LɎwtHg[h
\param  const char* file [in] tHgt@C
\author 
\date   create: update:$Date: 2005/08/15 05:23:13 $
*/
static void ReadFont(const char* file)
{
	monapi_cmemoryinfo* mi = monapi_call_file_decompress_st5_file(file, true);
	if (mi == NULL) return;
	
	default_font = mi;
}

/*!
\brief DrawWallPaper
	 ǎ`悷
\param  guiserver_bitmap* bmp [in] ǎ
\param  int pos [in] \ʒu
\param  unsigned int transparent [in] x (0x0-0xFFFFFF)
\param  const char* src [in] ǎt@C
\param  bool prompt [in] vvg\邩ǂ
\author 
\date   create: update:$Date: 2005/08/15 05:23:13 $
*/
static void DrawWallPaper(guiserver_bitmap* bmp, int pos, unsigned int transparent, const char* src, bool prompt)
{
	if (wallpaper == NULL || bmp == NULL) return;
	
	int x = 0, y = 0, ww = wallpaper->Width, wh = wallpaper->Height;
	switch (pos)
	{
		case 0: // Stretch
		{
			if (ww != bmp->Width || wh != bmp->Height)
			{
				if (prompt) printf("%s: Resizing %s....", GUI_SERVER_NAME, (const char*)src);
				guiserver_bitmap* bmp2 = ResizeBitmap(bmp, ww, wh);
				DisposeBitmap(bmp->Handle);
				bmp = bmp2;
				if (prompt) printf("Done\n");
			}
			break;
		}
		case 1: // Top Left
			break;
		case 2: // Top Center
			x = (ww - bmp->Width) / 2;
			break;
		case 3: // Top Right
			x = ww - bmp->Width;
			break;
		case 4: // Center Left
			y = (wh - bmp->Height) / 2;
			break;
		case 5: // Center Center
			x = (ww - bmp->Width) / 2;
			y = (wh - bmp->Height) / 2;
			break;
		case 6: // Center Right
			x = ww - bmp->Width;
			y = (wh - bmp->Height) / 2;
			break;
		case 7: // Bottom Left
			y = wh - bmp->Height;
			break;
		case 8: // Bottom Center
			x = (ww - bmp->Width) / 2;
			y = wh - bmp->Height;
			break;
		case 9: // Bottom Right
			x = ww - bmp->Width;
			y = wh - bmp->Height;
			break;
	}
	DrawImage(wallpaper, bmp, x, y, 0, 0, -1, -1, transparent);
	DisposeBitmap(bmp->Handle);
}

/*!
\brief DrawWallPaper
	 ǎ`悷
\param  const char* src [in] ǎt@C
\param  int pos [in] \ʒu
\param  unsigned int transparent [in] x (0x0-0xFFFFFF)
\param  int background [in] wiF (0x0-0xFFFFFF)
\author 
\date   create: update:$Date: 2005/08/15 05:23:13 $
*/
static void DrawWallPaper(const char* src, int pos, unsigned int transparent, int background)
{
	bool prompt = wallpaper_prompt;
	wallpaper_prompt = false;
	
	Screen* scr = GetDefaultScreen();
	if (wallpaper == NULL)
	{
		wallpaper = CreateBitmap(scr->getWidth(), scr->getHeight(), background);
		if (wallpaper == NULL) return;
	}
	else
	{
		FillColor(wallpaper, background);
	}
	
	guiserver_bitmap* bmp = ReadImage(src, prompt);
	if (bmp != NULL) DrawWallPaper(bmp, pos, transparent, src, prompt);
	DrawImage(screen_buffer, wallpaper);
	DrawScreen();
}


/*!
\brief ReadConfig
	 ݒt@C *.INI MonaForms̐ݒ𓾂
\author 
\date   create: update:$Date: 2005/08/15 05:23:13 $
*/
static void ReadConfig(List<char*>* pekoe)
{
	monapi_cmemoryinfo* cfg = monapi_call_file_read_data(pekoe->get(0), MONAPI_TRUE);
	if (cfg == NULL) return;
	
	if (startup != NULL)
	{
		delete startup;
		startup = NULL;
	}
	char line[256];
	int linepos = 0, wppos = 5;
	unsigned int wptp = 0, bgcol = 0;
	CString section, src;
	for (dword pos = 0; pos <= cfg->Size; pos++)
	{
		char ch = pos < cfg->Size ? (char)cfg->Data[pos] : '\n';
		if (ch == '\r' || ch == '\n')
		{
			if (linepos > 0)
			{
				CString ln(line, linepos);
				if (ln.toUpper().startsWith("REM "))
				{
					// ignore remark
				}
				else if (ln.startsWith("[") && ln.endsWith("]"))
				{
					section = ln.substring(1, ln.getLength() - 2).toUpper();
				}
				else if (ln.indexOf('=') > 0)
				{
					_A<CString> data = CString(line, linepos).split('=');
					if (data.get_Length() == 2 && data[0] != NULL && data[1] != NULL)
					{
						CString name = data[0].toUpper();
						if (section == "GENERAL")
						{
							if (name == "RUN")
							{
								if (startup == NULL) startup = new HList<CString>();
								_A<CString> runs = data[1].split(',');
								FOREACH (CString, r, runs) startup->add(r); END_FOREACH
							}
						}
						else if (section == "WALLPAPER")
						{
							if (name == "SOURCE")
							{
								src = data[1];
							}
							else if (name == "POSITION")
							{
								wppos = atoi(data[1]);
							}
							else if (name == "TRANSPARENCYKEY")
							{
								wptp = xtoui(data[1]);
							}
							else if (name == "BACKCOLOR")
							{
								bgcol = ((unsigned int)xtoui(data[1])) | 0xff000000;
							}
						}
						else if (section == "WINDOW EFFECT")
						{
							if (name == "CREATION")
							{
								we_creation = atoi(data[1]);
							}
							else if (name == "DESTRUCTION")
							{
								we_destruction = atoi(data[1]);
							}
							else if (name == "STEP")
							{
								we_step = atoi(data[1]);
							}
							else if (name == "WAIT")
							{
								we_wait = atoi(data[1]);
							}
						}
					}
				}
				linepos = 0;
			}
		}
		else if (linepos < 255)
		{
			line[linepos++] = ch;
		}
	}
	monapi_cmemoryinfo_dispose(cfg);
	monapi_cmemoryinfo_delete(cfg);
	if (src[0] == '\0') return;

	wallpaper_prompt = true;
	DrawWallPaper(src, wppos, wptp, bgcol);
}

/*!
\brief CheckGUIServer
	 MonaFormsT[o Nς݃`FbN
	 ɋNĂ΁A2dNIB
\author 
\date   create: update:$Date: 2005/08/15 05:23:13 $
*/
static void CheckGUIServer()
{
	syscall_set_ps_dump();
	PsInfo info;

	bool ok = true;
	CString self = "GUI.EX5";
	dword tid = MonAPI::System::getThreadID();

	while (syscall_read_ps_dump(&info) == 0)
	{
		if (ok && self == info.name && tid != info.tid) ok = false;
	}
	if (ok) return;

	printf("%s: already has executed!\n", GUI_SERVER_NAME);
	exit(1);
}

/*!
\brief MessageLoop
	 MonaFormsT[o bZ[W[v
\author 
\date   create: update:$Date: 2005/08/15 05:23:13 $
*/
static void MessageLoop()
{
	for (MessageInfo msg;;)
	{
		if (Message::receive(&msg)) continue;
		
		switch (msg.header)
		{
			// tHg擾v
			case MSG_GUISERVER_GETFONT:
				// tHg̃nhAtHg̃TCY
				Message::reply(&msg, default_font->Handle, default_font->Size);
				break;
			// ǎ[hv
			case MSG_GUISERVER_SETWALLPAPER:
				// t@CA\ʒuAxAwiF
				DrawWallPaper(msg.str, msg.arg1, msg.arg2, msg.arg3);
				Message::reply(&msg);
				break;
			// ʍXVv
			case MSG_GUISERVER_DRAWSCREEN:
				// x, y, w, h
				DrawScreen(msg.arg1, msg.arg2, GET_X_DWORD(msg.arg3), GET_Y_DWORD(msg.arg3));
				Message::reply(&msg);
				break;
			// o^v
			case MSG_REGISTER_TO_SERVER:
				// threadID
				clients.add(msg.arg1);
				Message::reply(&msg);
				break;
			// 폜v
			case MSG_UNREGISTER_FROM_SERVER:
				// threadID
				clients.remove(msg.arg1);
				Message::reply(&msg);
				break;
			// ESCL[ɂI`FbN
			case MSG_KEY_VIRTUAL_CODE:
			{
				if (msg.arg1 == Keys::Escape) {
					DisposeAllWindow();
					return;
				}
				if (ImageHandler(&msg)) break;
				if (WindowHandler(&msg)) break;
				break;
			}
			default:
				if (ImageHandler(&msg)) break;
				if (WindowHandler(&msg)) break;
				break;
		}
	}
}

static dword my_tid, stdout_tid;

/** Wo͂ԂXbh */
static void StdoutMessageLoop()
{
	MonAPI::Message::send(my_tid, MSG_SERVER_START_OK);

	for (MessageInfo msg;;)
	{
		if (MonAPI::Message::receive(&msg) != 0) continue;

		switch (msg.header)
		{
			case MSG_PROCESS_STDOUT_DATA:
			{
				MonAPI::Message::reply(&msg);
				dword tid1 = MonAPI::Message::lookupMainThread("GSHELL.EX5");
				if (tid1 != THREAD_UNKNOWN) {
					Message::send(tid1, MSG_PROCESS_STDOUT_DATA, 0, 0, 0, msg.str);
				}
				break;
			}
		}
	}
}

/** Wo͗p̃Xbh쐬 */
static void InitThread()
{
	my_tid = syscall_get_tid();
	dword id = syscall_mthread_create((dword)StdoutMessageLoop);
	syscall_mthread_join(id);
	MessageInfo msg, src;
	src.header = MSG_SERVER_START_OK;
	MonAPI::Message::receive(&msg, &src, MonAPI::Message::equalsHeader);
	stdout_tid = msg.from;
}

/*!
\brief MonaMain
	MonaFormsT[o C
\param List<char*>* pekoe [in] R}hC
\author
\date   create: update:$Date: 2005/08/15 05:23:13 $
*/
int MonaMain(List<char*>* pekoe)
{
	// `FbN
	if (pekoe->size() != 1)
	{
		printf("%s: usage GUI.EX5 [.INI FILE]");
		exit(1);
	}

	// 2dN`FbN
	CheckGUIServer();
	if (!InitScreen()) exit(1);

	MessageInfo msg_cp;
	if (Message::sendReceive(&msg_cp, monapi_get_server_thread_id(ID_PROCESS_SERVER), MSG_PROCESS_GET_COMMON_PARAMS) != 0)
	{
		printf("%s: can not get common parameters!\n", GUI_SERVER_NAME);
		exit(1);
	}
	commonParams = (CommonParameters*)MemoryMap::map(msg_cp.arg2);
	
	if (!monapi_register_to_server(ID_MOUSE_SERVER, MONAPI_TRUE)) exit(1);
	if (!monapi_register_to_server(ID_KEYBOARD_SERVER, MONAPI_TRUE)) exit(1);

	// tHg̃[h
	ReadFont("/APPS/MONA12.MF5");
	if (default_font == NULL) exit(1);
	
	// ݒt@C̃[h
	ReadConfig(pekoe);
	if (startup != NULL)
	{
		for (int i = 0; i < startup->size(); i++) {
			monapi_call_process_execute_file(startup->get(i), MONAPI_FALSE);
		}
	}

	// MONITORT[oւ̐Nʒm
	Message::send(Message::lookupMainThread("MONITOR.BIN"), MSG_SERVER_START_OK);

	InitThread();
	dword process = monapi_get_server_thread_id(ID_PROCESS_SERVER);
	if (process != THREAD_UNKNOWN)
	{
		MonAPI::Message::sendReceive(NULL, process + 1, MSG_PROCESS_GRAB_STDOUT, stdout_tid);
	}

	// bZ[W[v
	MessageLoop();

	if (process != THREAD_UNKNOWN)
	{
		MonAPI::Message::sendReceive(NULL, process + 1, MSG_PROCESS_UNGRAB_STDOUT, stdout_tid);
	}
	syscall_kill_thread(stdout_tid);

	// LɃ[hĂtHg̉
	monapi_cmemoryinfo_dispose(default_font);
	monapi_cmemoryinfo_delete(default_font);
	
	// ǎ̊J
	if (wallpaper != NULL) DisposeBitmap(wallpaper->Handle);
	DisposeScreen();
	
	monapi_register_to_server(ID_MOUSE_SERVER, MONAPI_FALSE);
	monapi_register_to_server(ID_KEYBOARD_SERVER, MONAPI_FALSE);
	MemoryMap::unmap(msg_cp.arg2);
	
	monapi_call_mouse_set_cursor(0);
	syscall_set_cursor(0,0);
	syscall_clear_screen();
	monapi_call_mouse_set_cursor(1);
	
	return 0;
}
